<?php

namespace SM\Controller;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use SM\Service\SmPropostasTaxasService;
use SM\Traits\TResponse;

class SmPropostasTaxasController
{
    use TResponse;
    protected $propostaTaxasservice;

    public function __construct(SmPropostasTaxasService $propostaTaxasservice)
    {
        $this->propostaTaxasservice = $propostaTaxasservice;
    }

    public function getTaxas()
    {
        try {
            $data = $this->propostaTaxasservice->getTaxas();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    } 

    public function saveTaxas(DTO\Request $request)
    {
        try {
            $data = $this->propostaTaxasservice->saveTaxas($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function deleteTaxas(DTO\Request $request)
    {
        try {
            $data = $this->propostaTaxasservice->deleteTaxas($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

}