<?php
namespace SM\Factory;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Traits\TQuery;

class SmPropostasAlimentacaoFactory
{

    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }
    public function getPropostasAlimentacao()
    {
        $sql = "SELECT 
                     o.NRSEQORCAMENTO, 
                     o.NRPARCNEGOCIO,
                     o.CDFILIAL,
                     o.NRORCAMENTO,
                     o.NRVERSAOORCAMENTO,
                     o.CDFILICONTATO,
                     o.NRCONTATO,
                     o.NRTIPOORCAMENTO,
                     o.NRPARCTRANSPORTADORA,
                     o.DTREFORCAMENTO,
                     o.CDPRECBASESERV,
                     o.CDREDUCONT,
                     o.IDFATURAORCA,
                     o.CDMODPGTO,
                     o.NRPARCINTERLOCUTOR,
                     o.NRGRUPOFATURA,
                     o.DSREFERENCIAORCA,
                     o.IDTRANSPORTADORA,
                     o.QTDIASVALIDADE,
                     o.DTVALIDADE,
                     o.QTDIASCONTRATO,
                     o.DTINICIOCONTRATO,
                     o.DTFIMCONTRATO,
                     o.NMPRINCIPALPARC,
                     o.DSEMAIL,
                     o.NMPARCINTERLOCUTOR,
                     o.NRTELEFONE,
                     o.DSOBSERVACAOORCA,
                     o.IDGERACONTRATO,
                     o.IDSITUACAOORCAMENTO,
                     o.VRORCAMENTO,
                     o.NRSEQORCAMENTOPAI,
                     o.CDSEQORCAMENTO,
                     o.NRORG,
                     o.IDATIVO,
                     o.DTINCLUSAO,
                     o.DTULTATU,
                     o.NRORGINCLUSAO,
                     o.CDOPERINCLUSAO,
                     o.NRORGULTATU,
                     o.CDOPERULTATU,
                     o.DSINTERORCA,
                     o.NRORCAMENTOMODELO,
                     om.NMORCAMENTOMODELO, 
                     es.NMTIPOORCAMENTO,
                     o.DTACEITEORCA,
                     o.NRSEQCONTATO,
                     o.NRSEQOPORT,
                     o.IDORCAFILHO,
                     o.NRORCAMENTORELAC,
                     o.NRDIASCARENCIA,
                     o.QTPARCELASFATU,
                     o.NRDIAVENCPARCELASFATU,
                     o.NRSEQINTERLOCUTOR,
                     o.CDOPERRESPONSAVEL,
                     o.IDPRODUTO,
                     o.DSJUSTIFCANCRENEG,
                     o.VRPERCMARKUP,
                     o.IDPROPALIMENTICIA,
                     o.VRPERCMARKUPAPLICADO,
                     o.NRSOLISERV,
                     o.DSALTERACONTRATUAIS,
                     o.IDASSELETRDIGITAL,
                     o.ISSUEID,
                     o.IDENVIADOCOPERRESPCONCASS,
                     o.JSONOMVALIDATEELEMENTS,
                     o.CDIDIOM,
                     o.NRMOEDA,
                     o.NRPARCINTERLOCUTORFAT,
                     o.NRREVENDA 
                 FROM fct_orcamento o
                 LEFT JOIN fct_orcamentomodelo om ON o.NRORCAMENTOMODELO = om.NRORCAMENTOMODELO
                 LEFT JOIN FCT_TIPOORCAMENTO es ON es.NRTIPOORCAMENTO = o.NRTIPOORCAMENTO";
    
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    } 
    
    public function getEscopoFaturamentoProposta($params){
        // Evitar SQL Injection
     
    
        $sql = " SELECT * 
                    FROM    FCT_TIPOORCAMENTO";
                           
    
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
        }
    public function getTabServicosPropostas()
    {
        $sql =  "SELECT *
        FROM FCT_RELACSERVORCAMENTO";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getFormacaoPreco()
    {
        $sql = "SELECT NRFORMPRECOSERVICO, NMFORMPRECOSERVICO
                 FROM FCT_FORMPRECOSERVICO";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getTabFormacaoPreco($params)
    {
        $sql = "SELECT 
                    NRRELACFORMINVEST,
                    NRINVESTIMENTO,
                    NRFORMPRECOSERVICO,
                    NRORG,
                    DTINCLUSAO,
                    DTULTATU,
                    NRORGINCLUSAO,
                    CDOPERINCLUSAO,
                    NRORGULTATU,
                    CDOPERULTATU,
                    IDATIVO
                FROM FCT_RELACFORMINVESTIMENTO
                WHERE NRINVESTIMENTO = :NRINVESTIMENTO";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function getComposicaoInvestimento($params)
    {
        $sql = "SELECT FCT_RELACSERVINVESTIMENTO.NRRELACSERVINVEST,
            FCT_RELACSERVINVESTIMENTO.NRINVESTIMENTO,
            FCT_RELACSERVINVESTIMENTO.NRCOMPSERVICO,
            FCT_COMPSERVICO.NMCOMPSERVICO,
            FCT_COMPSERVICO.NRCOMPSERVICOPAI,
            COMP_PAI.NMCOMPSERVICO AS NMCOMPSERVICOPAI,
            FCT_RELACSERVINVESTIMENTO.NRORG,
            FCT_RELACSERVINVESTIMENTO.DTINCLUSAO,
            FCT_RELACSERVINVESTIMENTO.NRORGINCLUSAO,
            FCT_RELACSERVINVESTIMENTO.CDOPERINCLUSAO,
            OPINC.NMOPERADOR AS NMOPERINCLUSAO,
            FCT_RELACSERVINVESTIMENTO.DTULTATU,
            FCT_RELACSERVINVESTIMENTO.NRORGULTATU,
            FCT_RELACSERVINVESTIMENTO.CDOPERULTATU,
            OPATU.NMOPERADOR AS NMOPERULTATU,
            FCT_RELACSERVINVESTIMENTO.IDATIVO
        FROM
            FCT_RELACSERVINVESTIMENTO
        INNER JOIN FCT_COMPSERVICO ON FCT_RELACSERVINVESTIMENTO.NRCOMPSERVICO = FCT_COMPSERVICO.NRCOMPSERVICO
        AND FCT_RELACSERVINVESTIMENTO.NRORG = FCT_COMPSERVICO.NRORG
        LEFT JOIN FCT_COMPSERVICO COMP_PAI ON FCT_COMPSERVICO.NRCOMPSERVICOPAI = COMP_PAI.NRCOMPSERVICO
        AND FCT_COMPSERVICO.NRORG = COMP_PAI.NRORG
        LEFT JOIN OPERADOR OPINC ON FCT_RELACSERVINVESTIMENTO.CDOPERINCLUSAO = OPINC.CDOPERADOR
        AND FCT_RELACSERVINVESTIMENTO.NRORG = OPINC.NRORG
        LEFT JOIN OPERADOR OPATU ON FCT_RELACSERVINVESTIMENTO.CDOPERULTATU = OPATU.CDOPERADOR
        AND FCT_RELACSERVINVESTIMENTO.NRORG = OPATU.NRORG
        WHERE FCT_RELACSERVINVESTIMENTO.NRINVESTIMENTO = :NRINVESTIMENTO";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }
    public function inserirRelacServInvest(array $params)
    {
        $sql = "INSERT INTO FCT_RELACSERVINVESTIMENTO 
                (NRRELACSERVINVEST, 
                 NRINVESTIMENTO, 
                 NRCOMPSERVICO, 
                 NRCOMPSERVICOPAI, 
                 NRORG, 
                 DTINCLUSAO, 
                 DTULTATU, 
                 NRORGINCLUSAO, 
                 CDOPERINCLUSAO, 
                 NRORGULTATU, 
                 CDOPERULTATU, 
                 IDATIVO)
        VALUES (:NRRELACSERVINVEST, 
                :NRINVESTIMENTO, 
                :NRCOMPSERVICO, 
                :NRCOMPSERVICOPAI, 
                :NRORG, 
                SYSDATE,
                NULL,
                :NRORGINCLUSAO, 
                :CDOPERINCLUSAO,  
                :NRORGULTATU, 
                :CDOPERULTATU, 
                :IDATIVO)";

        $this->connection->executeStatement($sql, $params);
    }

    public function atualizarRelacServInvest(array $params)
    {
        $sql = "UPDATE FCT_RELACSERVINVESTIMENTO SET 
                NRINVESTIMENTO = :NRINVESTIMENTO, 
                NRCOMPSERVICO = :NRCOMPSERVICO, 
                NRCOMPSERVICOPAI = :NRCOMPSERVICOPAI, 
                NRORG = :NRORG, 
                DTULTATU = SYSDATE,
                NRORGULTATU = :NRORGULTATU, 
                CDOPERULTATU = :CDOPERULTATU, 
                IDATIVO = :IDATIVO
            WHERE NRRELACSERVINVEST = :NRRELACSERVINVEST";

        $this->connection->executeStatement($sql, $params);
    }


    public function inserirInvestimento(array $params)
    {
        $sql = "INSERT INTO FCT_INVESTIMENTO 
                    (NRINVESTIMENTO,
                     DSINVESTIMENTO,
                     CDCATINVEST,
                     VRINVESTIMENTO,
                     QTMESARMOTIZACAO,
                     DTINCLUSAO,
                     NRORG,
                     DTULTATU,
                     NRORGINCLUSAO,
                     CDOPERINCLUSAO,
                     NRORGULTATU,
                     CDOPERULTATU,
                     IDATIVO)
             VALUES (:NRINVESTIMENTO,
                     :DSINVESTIMENTO,
                     :CDCATINVEST,
                     :VRINVESTIMENTO,
                     :QTMESARMOTIZACAO,
                     SYSDATE,
                     :NRORG,
                     NULL,
                     :NRORGINCLUSAO,
                     :CDOPERINCLUSAO,
                     NULL,
                     NULL,
                     :IDATIVO)";

        $this->connection->executeStatement($sql, $params);
    }

    public function atualizarInvestimento(array $params)
    {
        $sql = "UPDATE FCT_INVESTIMENTO SET 
                DSINVESTIMENTO = :DSINVESTIMENTO,
                CDCATINVEST = :CDCATINVEST,
                VRINVESTIMENTO = :VRINVESTIMENTO,
                QTMESARMOTIZACAO = :QTMESARMOTIZACAO,
                DTULTATU = SYSDATE,
                NRORGULTATU = :NRORGULTATU,
                CDOPERULTATU = :CDOPERULTATU,
                IDATIVO = :IDATIVO
            WHERE NRINVESTIMENTO = :NRINVESTIMENTO";

        $this->connection->executeStatement($sql, $params);
    }

    public function inserirRelacFormInvest(array $params)
    {
        $sql = "INSERT INTO FCT_RELACFORMINVESTIMENTO 
            (NRRELACFORMINVEST, 
             NRINVESTIMENTO, 
             NRFORMPRECOSERVICO, 
             NRORG, 
             DTINCLUSAO, 
             DTULTATU, 
             NRORGINCLUSAO, 
             CDOPERINCLUSAO, 
             NRORGULTATU, 
             CDOPERULTATU, 
             IDATIVO)
    VALUES (:NRRELACFORMINVEST, 
            :NRINVESTIMENTO, 
            :NRFORMPRECOSERVICO, 
            :NRORG, 
            SYSDATE,
            NULL,
            :NRORGINCLUSAO, 
            :CDOPERINCLUSAO,  
            :NRORGULTATU, 
            :CDOPERULTATU, 
            :IDATIVO)";

        $this->connection->executeStatement($sql, $params);
    }

    public function atualizarRelacFormInvest(array $params)
    {
        $sql = "UPDATE FCT_RELACFORMINVESTIMENTO SET 
            NRINVESTIMENTO = :NRINVESTIMENTO, 
            NRFORMPRECOSERVICO = :NRFORMPRECOSERVICO, 
            NRORG = :NRORG, 
            DTULTATU = SYSDATE,
            NRORGULTATU = :NRORGULTATU, 
            CDOPERULTATU = :CDOPERULTATU, 
            IDATIVO = :IDATIVO
        WHERE NRRELACFORMINVEST = :NRRELACFORMINVEST";

        $this->connection->executeStatement($sql, $params);
    }

    public function deleteInvest($parametros)
    {
        $sql2 = "DELETE FROM FCT_RELACFORMINVESTIMENTO
                WHERE NRRELACFORMINVEST IN (" . $parametros . ")";
        $this->connection->executeStatement($sql2);
        $sql1 = "DELETE FROM FCT_RELACSERVINVESTIMENTO
                WHERE NRRELACSERVINVEST IN (" . $parametros . ")";
        $this->connection->executeStatement($sql1);
        $sql = "DELETE FROM  FCT_INVESTIMENTO
                WHERE NRINVESTIMENTO IN (" . $parametros . ")";

        $this->connection->executeStatement($sql);
    }

    public function deleteComposi($parametros)
    {
        $sql = "DELETE FROM FCT_RELACSERVINVESTIMENTO
                WHERE NRRELACSERVINVEST IN (" . $parametros . ")";

        $this->connection->executeStatement($sql);
    }

    public function deleteFormPreco($parametros)
    {
        $sql = "DELETE FROM FCT_RELACFORMINVESTIMENTO
                WHERE NRRELACFORMINVEST IN (" . $parametros . ")";

        $this->connection->executeStatement($sql);
    }

    /**
     * Deleta alguns servicos do imposto
     **/
    public function deleteServicoImposto(array $params, $nrimposto)
    {
        $sql = "DELETE FROM FCT_RELACIMPOSTOSERV
                WHERE CDIMPOSTO = :CDIMPOSTO
                    AND NRORG   = :NRORG
                    AND NRIMPOSTOSERV IN($nrimposto)";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    /**
     * Salva a edição de um imposto relacionado a um serviço
     **/
    public function salvarEdicaoImposto(array $params)
    {
        $sql = "UPDATE FCT_RELACIMPOSTOSERV
                SET VRPRECIMPOSTO = :VRPRECIMPOSTO
                WHERE CDIMPOSTO = :CDIMPOSTO
                    AND NRORG   = :NRORG";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
}